unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes,
  Graphics, Controls, Forms,
  Dialogs, GLScene, GLVectorFileObjects, GLObjects,
  GLCoordinates,
  GLCrossPlatform, BaseClasses, GLWin32Viewer, Menus,
  StdCtrls, VectorTypes, GLGeomObjects,
  GLState, GLMesh, VectorGeometry, GLColor,jpeg,
  GLFile3DS, GLFileMD2, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLDummyCube1: TGLDummyCube;
    GLLightSource1: TGLLightSource;
    GLFreeForm1: TGLFreeForm;
    MainMenu1: TMainMenu;
    Archivos1: TMenuItem;
    Carga1: TMenuItem;
    Edit1: TEdit;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    Label1: TLabel;
    Salir1: TMenuItem;
    RadioGroup1: TRadioGroup;
    Lampara1: TMenuItem;
    Color1: TMenuItem;
    ColorDialog1: TColorDialog;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Carga1Click(Sender: TObject);
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton; Shift:
        TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X, Y:
        Integer);
    procedure Salir1Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure Color1Click(Sender: TObject);
  private
    { Private declarations }
    px,py : integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  GLFreeForm1.AutoCentering  := [macUseBarycenter];
end;

procedure TForm1.Carga1Click(Sender: TObject);
var
  nom : string;
begin
  if OpenDialog1.Execute then begin
    nom := OpenDialog1.FileName;
    GLFreeForm1.LoadFromFile(nom);
  end;
end;

procedure TForm1.Color1Click(Sender: TObject);
var
  cc  : integer;
begin
  if ColorDialog1.Execute then begin
    cc := ColorDialog1.Color;
    GLLightSource1.Diffuse.AsWinColor := cc;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  ss : single;
begin
  ss := StrToFloat(Edit1.Text);
  GLFreeForm1.Scale.SetVector(ss,ss,ss);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  R,ss : single;
begin
  R := GLFreeForm1.BoundingSphereRadiusUnscaled;
  Label1.Caption := FloatToStr(R);
  if R <> 0 then begin
    ss := 1/R;
    GLFreeForm1.Scale.SetVector(ss,ss,ss);
  end;
end;


procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
    Shift: TShiftState; X, Y: Integer);
begin
  px := x;
  py := y;
end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState;
    X, Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := x;
    py := y;
  end;

end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
var
  sc  : single;
begin
  sc := GLCamera1.SceneScale;
  sc := sc * 0.95;
  if sc < 0.1 then sc := 0.1;
  GLCamera1.SceneScale := sc;
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
var
  sc  : single;
begin
  sc := GLCamera1.SceneScale;
  sc := sc * 1.05;
  if sc > 4 then sc := 4;
  GLCamera1.SceneScale := sc;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  if RadioGroup1.ItemIndex=0
    then GLFreeForm1.Material.PolygonMode := pmLines
    else GLFreeForm1.Material.PolygonMode := pmFill
end;

procedure TForm1.Salir1Click(Sender: TObject);
begin
  Close();
end;

end.
